#! /usr/bin/perl -w

#
# Strip section headers from the Linux stub. Section headers are
# optional for executables, but nevertheless binutils (2.9.1.0.25)
# complain with a "File format not recognized" error.
# Looks like a bug in binutils to me.
#
# A positive side effect of this is that `strip' cannot ruin an UPX
# compressed file any longer.
#

$fname = shift || die;
sysopen (FH,$fname,2) || die;
binmode FH;

sysseek (FH,0x20,0) || die;
sysread (FH,$num,4) || die;
$shpos = unpack ("V",$num);

sysseek (FH,0x2e,0) || die;
sysread (FH,$num,2) || die;
$ssize = unpack ("v",$num);

sysseek (FH,0x32,0) || die;
sysread (FH,$num,2) || die;
$idx = unpack ("v",$num);

sysseek (FH,$shpos + $idx * $ssize + 16,0);
sysread (FH,$num,4) || die;
$neweof = unpack ("V",$num);

$num = pack ("x6");
sysseek (FH,0x20,0) || die;
syswrite (FH,$num,4) || die;

sysseek (FH,0x2e,0) || die;
syswrite (FH,$num,6) || die;

truncate (FH,$neweof) || die;
exit 0;
